// ////////////////////////////////////////////////////////////////////////// //
// see http://bjoern.hoehrmann.de/utf-8/decoder/dfa/
// for some recovery strategies it may be useful to determine the number of bytes expected.
static const uint8_t sxed_utf8dfa[0x16c] = {
  // maps bytes to character classes
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 00-0f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 10-1f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 20-2f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 30-3f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 40-4f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 50-5f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 60-6f
  0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00, // 70-7f
  0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01,0x01, // 80-8f
  0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09,0x09, // 90-9f
  0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07, // a0-af
  0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07,0x07, // b0-bf
  0x08,0x08,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02, // c0-cf
  0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02,0x02, // d0-df
  0x0a,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x03,0x04,0x03,0x03, // e0-ef
  0x0b,0x06,0x06,0x06,0x05,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08,0x08, // f0-ff
  // maps a combination of a state of the automaton and a character class to a state
  0x00,0x0c,0x18,0x24,0x3c,0x60,0x54,0x0c,0x0c,0x0c,0x30,0x48,0x0c,0x0c,0x0c,0x0c, // 100-10f
  0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x00,0x0c,0x0c,0x0c,0x0c,0x0c,0x00, // 110-11f
  0x0c,0x00,0x0c,0x0c,0x0c,0x18,0x0c,0x0c,0x0c,0x0c,0x0c,0x18,0x0c,0x18,0x0c,0x0c, // 120-12f
  0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x18,0x0c,0x0c,0x0c,0x0c,0x0c,0x18,0x0c,0x0c, // 130-13f
  0x0c,0x0c,0x0c,0x0c,0x0c,0x18,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x24, // 140-14f
  0x0c,0x24,0x0c,0x0c,0x0c,0x24,0x0c,0x0c,0x0c,0x0c,0x0c,0x24,0x0c,0x24,0x0c,0x0c, // 150-15f
  0x0c,0x24,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c,0x0c
};


// replacement char for invalid unicode
#define SXED_UTF8_REPLACEMENT_CP  (0xFFFDU)


// ////////////////////////////////////////////////////////////////////////// //
static inline /*__attribute__((always_inline))*/ __attribute__((unused))
// is the given codepoint valid?
int sxed_utf8_valid_cp (uint32_t cp) { return (cp < 0xD800U || (cp > 0xDFFFU && cp <= 0x10FFFFU)); }

static inline /*__attribute__((always_inline))*/ __attribute__((unused))
// is the given codepoint considered printable?
// i restrict it to some useful subset
// unifuck is unifucked, but i hope that i sorted out all idiotic diactritics and control chars
int sxed_utf8_printable_cp (uint32_t cp) {
  return
    // basic latin
    cp <= 0x024FU ||
    // some greek, and cyrillic w/o combiners
    (cp >= 0x0390U && cp <= 0x0482U) ||
    (cp >= 0x048AU && cp <= 0x052FU) ||
    // runic (just for fun)
    (cp >= 0x16A0U && cp <= 0x168FU) ||
    // latin extended additional
    (cp >= 0x1E00U && cp <= 0x1EFFU) ||
    // some general punctuation, extensions, etc.
    (cp >= 0x2000U && cp <= 0x2C7FU) ||
    // supplemental punctuation
    (cp >= 0x2E00U && cp <= 0x2E42U) ||
    // more latin extended
    (cp >= 0xAB30U && cp <= 0xAB65U);
}


// ////////////////////////////////////////////////////////////////////////// //
// DFA-based utf-8 decoder with only 32 bits of state
// "overlong" variants accept "zero overlong" (0xC0 0x80), but are slower
// normal variants reject overlongs
//
// use like this:
//
//   uint32_t cp = 0; // 0 is important! (also, assigning zero can be used to reset the decoder)
//   for (;;) {
//     cp = sxed_utf8d_consume(cp, next_byte());
//     if (sxed_utf8_valid_cp(cp)) {
//        ...process unicode codepoint from `cp`...
//     }
//   }
//
// or:
//
//   uint32_t cp = 0; // 0 is important! (also, assigning zero can be used to reset the decoder)
//   for (;;) {
//     cp = sxed_utf8d_consume_ex(cp, next_byte());
//     if (sxed_utf8_valid_cp(cp)) {
//        ...process unicode codepoint from `cp`...
//     } else if (sxed_utf8d_fuckedup(cp)) {
//        ...we found an invalid utf-8 sequence...
//     }
//   }

static inline /*__attribute__((always_inline))*/ __attribute__((unused))
// never reaches `invalid` state, returns `replacement` for invalid chars
// returns invalid codepoint while it is "in progress" (i.e. result > 0x10FFFFU)
uint32_t sxed_utf8d_consume (uint32_t cp, const char ch) {
  uint8_t state = cp>>24;
  if (state == 12/*State.Reject*/) state = 0/*State.Accept*/; // invalid utf-8 sequence was hit, restart (just in case)
  const uint8_t type = sxed_utf8dfa[((uint8_t)ch)];
  cp = (state /*!= State.Accept*/ ? (((uint8_t)ch)&0x3fU)|((cp&~0xff000000U)<<6) : (0xff>>type)&((uint8_t)ch));
  if ((state = sxed_utf8dfa[256+state+type]) == 12/*State.Reject*/) return SXED_UTF8_REPLACEMENT_CP; // invalid utf-8 sequence
  return
    state ? cp|((uint32_t)state<<24) :
    sxed_utf8_valid_cp(cp) ? cp : //k8: i don't remember if this is required, but it's better be safe than sorry
    SXED_UTF8_REPLACEMENT_CP;
}

static inline /*__attribute__((always_inline))*/ __attribute__((unused))
// can reach `invalid` state
// returns invalid codepoint while it is "in progress" (i.e. result > 0x10FFFFU)
// on invalid utf-8 sequence, returns special value that can be tested with `sxed_utf8d_fuckedup()`
// codepoint is undefined in this case (but it won't pass `sxed_utf8_valid_cp()`)
// next call will restart decoding
uint32_t sxed_utf8d_consume_ex (uint32_t cp, const char ch) {
  uint8_t state = cp>>24;
  if (state == 12/*State.Reject*/) state = 0/*State.Accept*/; // invalid utf-8 sequence was hit, restart (just in case)
  const uint8_t type = sxed_utf8dfa[((uint8_t)ch)];
  cp = (state /*!= State.Accept*/ ? (((uint8_t)ch)&0x3fU)|((cp&~0xff000000U)<<6) : (0xff>>type)&((uint8_t)ch));
  if ((state = sxed_utf8dfa[256+state+type]) == 12/*State.Reject*/) return 12U<<24; // invalid utf-8 sequence
  return
    state ? cp|((uint32_t)state<<24) :
    sxed_utf8_valid_cp(cp) ? cp : //k8: i don't remember if this is required, but it's better be safe than sorry
    12U<<24; // invalid utf-8 sequence
}

static inline /*__attribute__((always_inline))*/ __attribute__((unused))
// check value returned from `sxed_utf8d_consume_ex()` with this
// returns non-zero if last decoding operation hit invalid utf-8 sequence
// codepoint is undefined in this case (but it won't pass `sxed_utf8_valid_cp()`)
int sxed_utf8d_fuckedup (const uint32_t cp) { return ((cp>>24) == 12); }
